"use strict";
{
	const C3 = self.C3;
	C3.Plugins.VinoosTapsellPlus.Instance = class VinoosTapsellPlusSingleGlobalInstance extends C3.SDKInstanceBase
	{
		constructor(inst, properties)
		{
			super(inst);
			this.errorMessage= "";
			this.isSupported = false;
			var self = this;
			var appKey = properties[0];
			if (typeof cordova == 'undefined')
            {
                return;
            }
            else
            {
				TapsellPlus.initialize(appKey);
				this.isSupported = true;
				console.log("init TapsellPlus is done");
				document.addEventListener('response',function(data){
					switch(data.adType) {
						case 'banner':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onBannerAvailable);						
							break;
						case 'interstitial':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onInterstitialAvailable);
							break;
						case 'rewardedVideo':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onRewardedVideoAvailable);
							break;
					}
				});
				document.addEventListener('error',function(data){
					this.errorMessage = data.message;
					switch(data.adType) {
						case 'banner':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onBannerNoAdAvailable);
							break;
						case 'interstitial':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onInterstitialNoAdAvailable);
							break;
						case 'rewardedVideo':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onRewardedVideoNoAdAvailable);
							break;
					}
				});
				document.addEventListener('onError',function(data){
					this.errorMessage = data.message;
					switch(data.adType) {
						case 'interstitial':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onInterstitialError);
							break;
						case 'rewardedVideo':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onRewardedVideoError);
							break;
					}
				});
				document.addEventListener('onOpened',function(data){
					switch(data.adType) {
						case 'interstitial':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onInterstitialOpened);
							break;
						case 'rewardedVideo':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onRewardedVideoOpened);
							break;
					}
				});
				document.addEventListener('onClosed',function(data){
					switch(data.adType) {
						case 'interstitial':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onInterstitialClosed);
							break;
						case 'rewardedVideo':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onRewardedVideoClosed);
							break;
					}
				});
				document.addEventListener('onRewarded',function(data){
					switch(data.adType) {
						case 'interstitial':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onInterstitialRewarded);
							break;
						case 'rewardedVideo':
							self.Trigger(C3.Plugins.VinoosTapsellPlus.Cnds.onRewardedVideoRewarded);
							break;
					}
				});
            }
		}
		
		Release()
		{
			super.Release();
		}
		SaveToJson()
		{
			return {};
		}
		LoadFromJson(o)
		{}
	};
}
